import { ValidatorFn, AbstractControl } from '@angular/forms';
/**
 * Conditional validators
 */
export declare class ConditionalValidators {
    /**
     * Custom validation with condition
     * @param state condition to set the validators
     * @param validators validators array to set
     * @param controls controls to detect changes in their values
     */
    static custom(state: () => boolean, validators: ValidatorFn[], controls?: (AbstractControl | string)[]): ValidatorFn;
    /**
     * Validation with condition equal to value
     * @param conditions conditions like object (key is control name)
     * @param validators validators array
     * @param controls controls to detect changes in their values
     */
    static equal(conditions: {
        [key: string]: any;
    }, validators: ValidatorFn[], controls?: (AbstractControl | string)[]): ValidatorFn;
    /**
     * Clean subscriptions for changes in control value
     * @param control controls array
     */
    private static cleanChangeSubscriptions;
    /**
     * Subscribe to changes in the values of the controls to validate the main control
     * @param control main control
     * @param controls controls array
     */
    private static pushChangeSubscriptions;
    /**
     * Get the control object from group parent
     * @param name control name to get
     * @param group group parent
     */
    private static getControlByName;
    /**
     * Get abstract control array
     * @param control main control
     * @param controls abstract controls or abstract controls name
     */
    private static toRealControls;
}
